Index: EcnlProtoTool/trunk/ntshell/src/bits/alltypes.h
===================================================================
--- EcnlProtoTool/trunk/ntshell/src/bits/alltypes.h	(revision 331)
+++ EcnlProtoTool/trunk/ntshell/src/bits/alltypes.h	(revision 331)
@@ -0,0 +1,1 @@
+#include "../musl-1.1.18/include/bits/alltypes.h"
Index: EcnlProtoTool/trunk/ntshell/src/bits/fcntl.h
===================================================================
--- EcnlProtoTool/trunk/ntshell/src/bits/fcntl.h	(revision 331)
+++ EcnlProtoTool/trunk/ntshell/src/bits/fcntl.h	(revision 331)
@@ -0,0 +1,1 @@
+#include "../musl-1.1.18/include/bits/fcntl.h"
Index: EcnlProtoTool/trunk/ntshell/src/bits/ioctl_fix.h
===================================================================
--- EcnlProtoTool/trunk/ntshell/src/bits/ioctl_fix.h	(revision 331)
+++ EcnlProtoTool/trunk/ntshell/src/bits/ioctl_fix.h	(revision 331)
@@ -0,0 +1,1 @@
+#include "../musl-1.1.18/include/bits/ioctl_fix.h"
Index: EcnlProtoTool/trunk/ntshell/src/bits/signal.h
===================================================================
--- EcnlProtoTool/trunk/ntshell/src/bits/signal.h	(revision 331)
+++ EcnlProtoTool/trunk/ntshell/src/bits/signal.h	(revision 331)
@@ -0,0 +1,1 @@
+#include "../musl-1.1.18/include/bits/signal.h"
Index: EcnlProtoTool/trunk/ntshell/src/bits/socket.h
===================================================================
--- EcnlProtoTool/trunk/ntshell/src/bits/socket.h	(revision 331)
+++ EcnlProtoTool/trunk/ntshell/src/bits/socket.h	(revision 331)
@@ -0,0 +1,1 @@
+#include "../musl-1.1.18/include/bits/socket.h"
Index: EcnlProtoTool/trunk/ntshell/src/fdtable.c
===================================================================
--- EcnlProtoTool/trunk/ntshell/src/fdtable.c	(revision 321)
+++ EcnlProtoTool/trunk/ntshell/src/fdtable.c	(revision 331)
@@ -35,17 +35,10 @@
  *  @(#) $Id$
  */
+#include "shellif.h"
 #include <stdint.h>
-#include <stdio.h>
-#include <sys/unistd.h>
-#include <limits.h>
 #include <kernel.h>
 #include <t_syslog.h>
 #include <t_stdlib.h>
 #include <sil.h>
-#include <stdlib.h>
-#include <string.h>
-#include <stdio.h>
-#include <setjmp.h>
-#include "../../../musl-1.1.12/include/poll.h"
 #include "syssvc/serial.h"
 #include "syssvc/syslog.h"
@@ -61,8 +54,9 @@
 #include <net/if_var.h>
 #include <netinet/udp_var.h>
-#include <ethernet_api.h>
+//#include <ethernet_api.h>
 #include "ff.h"
 #include "socket_stub.h"
 #include "kernel_cfg.h"
+#include <string.h>
 
 #define SIO_PORTID 1
@@ -71,11 +65,12 @@
 #define IO_TYPE_SIO		1
 #define IO_TYPE_FILE	2
-#define IO_TYPE_TCP		3
-#define IO_TYPE_UDP		4
+#define IO_TYPE_DIR		3
+#define IO_TYPE_TCP		4
+#define IO_TYPE_UDP		5
 
 static struct _IO_FILE fd_table[8 * sizeof(FLGPTN)] = {
-	{ 0, IO_TYPE_SIO, 0, stdio_close, stdin_read, stdio_write },
-	{ 1, IO_TYPE_SIO, 0, stdio_close, stdio_read, stdout_write },
-	{ 2, IO_TYPE_SIO, 0, stdio_close, stdio_read, stderr_write },
+	{ 0, IO_TYPE_SIO, 0, stdio_close, stdin_read, stdio_write, sio_seek, sio_ioctl },
+	{ 1, IO_TYPE_SIO, 0, stdio_close, stdio_read, stdout_write, sio_seek, sio_ioctl },
+	{ 2, IO_TYPE_SIO, 0, stdio_close, stdio_read, stderr_write, sio_seek, sio_ioctl },
 };
 #define fd_table_count (sizeof(fd_table) / sizeof(fd_table[0]))
@@ -94,5 +89,5 @@
 	}
 
-	return -1;
+	return -ENOMEM;
 }
 
@@ -112,5 +107,5 @@
 	struct _IO_FILE *fp = id_to_fd(type, id);
 	if (fp == NULL)
-		return -1;
+		return -EBADF;
 
 	memset(fp, 0, sizeof(struct _IO_FILE));
@@ -136,4 +131,6 @@
 	fp->read = sio_read;
 	fp->write = sio_write;
+	fp->seek = sio_seek;
+	fp->ioctl = sio_ioctl;
 
 	return fp;
@@ -160,4 +157,6 @@
 	fp->read = file_read;
 	fp->write = file_write;
+	fp->seek = file_seek;
+	fp->ioctl = file_ioctl;
 
 	return fp;
@@ -172,4 +171,30 @@
 {
 	return id_to_fd(IO_TYPE_FILE, fileid);
+}
+
+struct _IO_FILE *new_dir_fd(int fileid)
+{
+	int fd = new_fd(IO_TYPE_DIR, fileid);
+	if ((fd < 0) || (fd >= fd_table_count))
+		return NULL;
+
+	struct _IO_FILE *fp = &fd_table[fd];
+	fp->close = dir_close;
+	fp->read = dir_read;
+	fp->write = dir_write;
+	fp->seek = dir_seek;
+	fp->ioctl = dir_ioctl;
+
+	return fp;
+}
+
+int delete_dir_fd(int dirid)
+{
+	return delete_fd(IO_TYPE_DIR, dirid);
+}
+
+struct _IO_FILE *dirid_to_fd(int dirid)
+{
+	return id_to_fd(IO_TYPE_DIR, dirid);
 }
 
@@ -184,4 +209,6 @@
 	fp->read = tcp_fd_read;
 	fp->write = tcp_fd_write;
+	fp->seek = tcp_fd_seek;
+	fp->ioctl = tcp_fd_ioctl;
 
 	return fp;
@@ -208,4 +235,6 @@
 	fp->read = udp_fd_read;
 	fp->write = udp_fd_write;
+	fp->seek = udp_fd_seek;
+	fp->ioctl = udp_fd_ioctl;
 
 	return fp;
@@ -220,16 +249,4 @@
 {
 	return id_to_fd(IO_TYPE_UDP, udpid);
-}
-
-int shell_isatty(int fd)
-{
-	if ((fd < 0) || (fd >= fd_table_count))
-		return 0;
-
-	struct _IO_FILE *fp = &fd_table[fd];
-	if (fp->type == IO_TYPE_SIO)
-		return 1;
-
-	return 0;
 }
 
@@ -245,5 +262,5 @@
 #define TMO_MAX INT_MAX
 
-int select(int n, fd_set *rfds, fd_set *wfds, fd_set *efds, struct timeval *tv)
+int shell_select(int n, fd_set *__restrict rfds, fd_set *__restrict wfds, fd_set *__restrict efds, struct timeval *__restrict tv)
 {
 	ER ret;
@@ -277,8 +294,8 @@
 	}
 
-	return -1;
-}
-
-int poll(struct pollfd *fds, nfds_t nfds, int timeout)
+	return -EBADF;
+}
+
+int shell_poll(struct pollfd *fds, nfds_t nfds, int timeout)
 {
 	ER ret;
@@ -334,5 +351,5 @@
 	}
 
-	return -1;
+	return -EBADF;
 }
 
@@ -541,2 +558,11 @@
 	}
 }
+
+int shell_ioctl(int fd, int request, void *arg)
+{
+	struct _IO_FILE *fp = fd_to_fp(fd);
+	if (fp == NULL)
+		return -EBADF;
+
+	return fp->ioctl(fp, request, arg);
+}
Index: EcnlProtoTool/trunk/ntshell/src/features.h
===================================================================
--- EcnlProtoTool/trunk/ntshell/src/features.h	(revision 331)
+++ EcnlProtoTool/trunk/ntshell/src/features.h	(revision 331)
@@ -0,0 +1,1 @@
+#include "../musl-1.1.18/include/features.h"
Index: EcnlProtoTool/trunk/ntshell/src/io_stub.c
===================================================================
--- EcnlProtoTool/trunk/ntshell/src/io_stub.c	(revision 321)
+++ EcnlProtoTool/trunk/ntshell/src/io_stub.c	(revision 331)
@@ -35,9 +35,6 @@
  *  @(#) $Id$
  */
+#include "shellif.h"
 #include <stdint.h>
-#include <stdio.h>
-#include <sys/unistd.h>
-#include <limits.h>
-#include <fcntl.h>
 #include "ff.h"
 #include <kernel.h>
@@ -45,7 +42,5 @@
 #include <t_stdlib.h>
 #include <sil.h>
-#include <stdlib.h>
 #include <string.h>
-#include <stdio.h>
 #include <setjmp.h>
 #include "syssvc/syslog.h"
@@ -61,18 +56,59 @@
 #include <net/if_var.h>
 #include <netinet/udp_var.h>
-#include <ethernet_api.h>
-#include "ff.h"
+//#include <ethernet_api.h>
 #include "socket_stub.h"
-#include "../../../musl-1.1.12/include/_dirent.h"
-#include "../../../musl-1.1.12/include/_termios.h"
-#include "ntstdio.h"
-
-int shell_open(const char * path, int flags)
-{
-	FRESULT res;
-
-	struct _IO_FILE *fp = new_file_fd(0);
-	if (fp == NULL)
-		return -1;
+//#include <sys/stat.h>
+#include "util/ntstdio.h"
+#include "usrcmd.h"
+#include "core/ntlibc.h"
+
+int fresult2errno(FRESULT res)
+{
+	switch (res) {
+	case FR_INVALID_OBJECT:
+		return -EINVAL;
+	case FR_TOO_MANY_OPEN_FILES:
+		return -ENOMEM;
+	case FR_NO_FILE:
+	case FR_NO_PATH:
+	case FR_INVALID_DRIVE:
+	case FR_INVALID_NAME:
+		return -ENOENT;
+	case FR_DISK_ERR:
+	case FR_NO_FILESYSTEM:
+	case FR_NOT_ENABLED:
+		return -ENODEV;
+	case FR_WRITE_PROTECTED:
+	case FR_DENIED:
+		return -EACCES;
+	case FR_EXIST:
+		return -EEXIST;
+	case FR_INT_ERR:
+	default:
+		return -EIO;
+	}
+}
+
+int shell_open(const char * path, int flags, void *arg)
+{
+	FRESULT res;
+	struct _IO_FILE *fp;
+
+	if (flags & O_DIRECTORY) {
+		fp = new_dir_fd(0);
+		if (fp == NULL)
+			return -ENOMEM;
+
+		DIR *dir = &fp->dir;
+		FRESULT res;
+		if ((res = f_opendir(dir, path)) != FR_OK) {
+			return fresult2errno(res);
+		}
+		return 0;
+	}
+
+	fp = new_file_fd(0);
+	if (fp == NULL)
+		return -ENOMEM;
 
 	BYTE fmd = 0;
@@ -115,5 +151,5 @@
 	}
 
-	return -1;
+	return fresult2errno(res);
 }
 
@@ -126,5 +162,5 @@
 	}
 
-	return -1;
+	return -EINVAL;
 }
 
@@ -135,5 +171,5 @@
 
 	if ((res = f_read(&fp->file, data, len, &ret)) != FR_OK)
-		return -1;
+		return -EIO;
 
 	return ret;
@@ -146,47 +182,111 @@
 
 	if ((res = f_write(&fp->file, data, len, &ret)) != FR_OK)
-		return -1;
+		return -EIO;
 
 	return ret;
 }
 
+off_t file_seek(struct _IO_FILE *fp, off_t ptr, int dir)
+{
+	switch (dir) {
+	case SEEK_SET:
+		dir = F_SEEK_SET;
+		break;
+	case SEEK_CUR:
+		dir = F_SEEK_CUR;
+		break;
+	case SEEK_END:
+		dir = F_SEEK_END;
+		break;
+	default:
+		return -EINVAL;
+	}
+
+	FRESULT res;
+	if ((res = f_seek(&fp->file, ptr, dir)) != FR_OK)
+		return -EIO;
+
+	return fp->file.fptr;
+}
+
+int file_ioctl(struct _IO_FILE *fp, int req, void *arg)
+{
+	DRESULT res;
+
+	if ((res = disk_ioctl(fp->file.fs->drv, req, arg) != RES_OK))
+		return -EINVAL;
+
+	return 0;
+}
+
 int shell_close(int fd)
 {
 	struct _IO_FILE *fp = fd_to_fp(fd);
 	if (fp == NULL)
-		return -1;
+		return -EBADF;
 
 	return fp->close(fp);
 }
 
-int shell_read(int fd, char *data, int len)
-{
-	struct _IO_FILE *fp = fd_to_fp(fd);
-	if (fp == NULL)
-		return -1;
+ssize_t shell_read(int fd, void *data, size_t len)
+{
+	struct _IO_FILE *fp = fd_to_fp(fd);
+	if (fp == NULL)
+		return -EBADF;
 
 	return fp->read(fp, (unsigned char *)data, len);
 }
 
-int shell_write(int fd, char *data, int len)
-{
-	struct _IO_FILE *fp = fd_to_fp(fd);
-	if (fp == NULL)
-		return -1;
+int shell_readv(int fd, const struct iovec *iov, int iovcnt)
+{
+	int result = 0;
+	struct _IO_FILE *fp = fd_to_fp(fd);
+	if (fp == NULL)
+		return -EBADF;
+
+	const struct iovec *end = &iov[iovcnt];
+	for (; iov < end; iov++) {
+		result += fp->read(fp, (unsigned char *)iov->iov_base, iov->iov_len);
+	}
+
+	return result;
+}
+
+ssize_t shell_write(int fd, const void *data, size_t len)
+{
+	struct _IO_FILE *fp = fd_to_fp(fd);
+	if (fp == NULL)
+		return -EBADF;
 
 	return fp->write(fp, (unsigned char *)data, len);
 }
 
-int shell_lseek(int fd, int ptr, int dir)
-{
-	struct _IO_FILE *fp = fd_to_fp(fd);
-	if (fp == NULL)
-		return -1;
-
-	FRESULT res;
-	if ((res = f_seek(&fp->file, ptr, dir)) != FR_OK)
-		return -1;
-
-	return fp->file.fptr;
+int shell_writev(int fd, const struct iovec *iov, int iovcnt)
+{
+	int result = 0;
+	struct _IO_FILE *fp = fd_to_fp(fd);
+	if (fp == NULL)
+		return -EBADF;
+
+	const struct iovec *end = &iov[iovcnt];
+	for (; iov < end; iov++) {
+		result += fp->write(fp, (unsigned char *)iov->iov_base, iov->iov_len);
+	}
+
+	return result;
+}
+
+int shell_llseek(int fd, off_t ptr, off_t *result, int dir)
+{
+	struct _IO_FILE *fp = fd_to_fp(fd);
+	if (fp == NULL)
+		return -EBADF;
+
+	off_t ret = fp->seek(fp, ptr, dir);
+	if (ret < 0)
+		return ret;
+
+	*result = ret;
+	return 0;
 }
 
@@ -195,5 +295,5 @@
 	struct _IO_FILE *fp = fd_to_fp(fd);
 	if (fp == NULL)
-		return -1;
+		return -EBADF;
 
 	memset(st, 0, sizeof(*st));
@@ -203,34 +303,31 @@
 }
 
-int fsync(int fd)
-{
-	struct _IO_FILE *fp = fd_to_fp(fd);
-	if (fp == NULL)
-		return -1;
-	return -1;
-}
-
-int ftruncate(int fd, off_t length)
-{
-	struct _IO_FILE *fp = fd_to_fp(fd);
-	if (fp == NULL)
-		return -1;
+int shell_fsync(int fd)
+{
+	struct _IO_FILE *fp = fd_to_fp(fd);
+	if (fp == NULL)
+		return -EBADF;
+	return -EIO;
+}
+
+int shell_ftruncate(int fd, off_t length)
+{
+	struct _IO_FILE *fp = fd_to_fp(fd);
+	if (fp == NULL)
+		return -EBADF;
 
 	FRESULT res;
 	if ((res = f_truncate(&fp->file)) != FR_OK)
-		return -1;
-
-	return 0;
-}
-
-int ioctl(int fd, int request, va_list ap)
-{
-	struct _IO_FILE *fp = fd_to_fp(fd);
-	if (fp == NULL)
-		return -1;
-	return -1;
-}
-
-int tcgetattr(int fd, struct termios *termios)
+		return fresult2errno(res);
+
+	return 0;
+}
+
+int shell_fcntl(int fd, int cmd, void *arg)
+{
+	return shell_ioctl(fd, cmd, arg);
+}
+
+int sio_tcgetattr(int fd, struct termios *termios)
 {
 	extern ntstdio_t ntstdio;
@@ -265,9 +362,9 @@
 		return 0;
 	}
-	abort();
-	return 0;
-}
-
-int tcsetattr(int fd, int optional_actions, const struct termios *termios)
+	shell_abort();
+	return 0;
+}
+
+int sio_tcsetattr(int fd, int optional_actions, const struct termios *termios)
 {
 	extern ntstdio_t ntstdio;
@@ -300,9 +397,9 @@
 		return 0;
 	}
-	abort();
-	return 0;
-}
-
-int shell_stat(const char *path, struct stat *st)
+	shell_abort();
+	return 0;
+}
+
+int shell_stat(const char *__restrict path, struct stat *__restrict st)
 {
 	FILINFO fi;
@@ -313,27 +410,29 @@
 	fi.lfsize = sizeof lfn;
 #endif
-	if (strcmp(path, ".") == 0) {
+	if (ntlibc_strcmp(path, ".") == 0) {
 		char cwd[_MAX_LFN];
 		if ((ret = f_getcwd(cwd, sizeof(cwd))) != FR_OK) {
-		return -1;
-		}
-		int l = strlen(cwd);
+			return fresult2errno(ret);
+		}
+		int l = ntlibc_strlen(cwd);
 		// ルートディレクトリの場合
 		if (cwd[l - 2] == ':' && cwd[l - 1] == '/') {
 			st->st_size = 0;
-			st->st_mtime = 0;
+			st->st_mtim.tv_nsec = 0;
+			st->st_mtim.tv_sec = 0;
 			st->st_mode = S_IFDIR;
 			return 0;
 		}
 		if ((ret = f_stat(cwd, &fi)) != FR_OK) {
-			return -1;
+			return fresult2errno(ret);
 		}
 	}
 	else if ((ret = f_stat(path, &fi)) != FR_OK) {
-		return -1;
+		return fresult2errno(ret);
 	}
 
 	st->st_size = fi.fsize;
-	st->st_mtime = fi.fdate + fi.ftime;
+	st->st_mtim.tv_nsec = 0;
+	st->st_mtim.tv_sec = fi.fdate + fi.ftime;
 	st->st_mode  = (S_IRUSR | S_IRGRP | S_IROTH);
 	st->st_mode |= (fi.fattrib & AM_RDO) ? 0 : (S_IWUSR | S_IWGRP | S_IWOTH);
@@ -343,7 +442,12 @@
 }
 
-int shell_link(void)
-{
-	return -1;
+int shell_lstat(const char *__restrict path, struct stat *__restrict st)
+{
+	return shell_stat(path, st);
+}
+
+int shell_link(const char *a, const char *b)
+{
+	return -EPERM;
 }
 
@@ -353,15 +457,15 @@
 
 	if ((res = f_unlink(path)) != FR_OK)
-		return -1;
-
-	return 0;
-}
-
-int rmdir(const char *path)
+		return -EIO;
+
+	return 0;
+}
+
+int shell_rmdir(const char *path)
 {
 	FRESULT res;
 
 	if ((res = f_unlink(path)) != FR_OK)
-		return -1;
+		return -EIO;
 
 	return 0;
@@ -373,14 +477,17 @@
 
 	if ((res = f_rename(oldpath, newpath)) != FR_OK)
-		return -1;
-	return 0;
-}
-
-int mkdir(const char *path, mode_t mode)
+		return fresult2errno(res);
+	return 0;
+}
+
+#define S_IREAD S_IRUSR
+#define S_IWRITE S_IWUSR
+
+int shell_mkdir(const char *path, mode_t mode)
 {
 	FRESULT res;
 
 	if ((res = f_mkdir(path)) != FR_OK)
-		return -1;
+		return fresult2errno(res);
 
 	BYTE attr = 0;
@@ -397,13 +504,13 @@
 
 	if((res = f_chmod(path, attr, mask)) != FR_OK) {
-		return -1;
-	}
-
-	return 0;
-}
-
-int chmod(const char *path, mode_t mode)
-{
-	FRESULT ret;
+		return fresult2errno(res);
+	}
+
+	return 0;
+}
+
+int shell_chmod(const char *path, mode_t mode)
+{
+	FRESULT res;
 	BYTE attr = 0;
 	BYTE mask = AM_RDO | AM_SYS; // AM_ARC, AM_HID
@@ -418,12 +525,12 @@
 	}
 
-	if((ret = f_chmod(path, attr, mask)) != FR_OK) {
-		return -1;
-	}
-
-	return 0;
-}
-
-char *getcwd(char *buf, size_t size)
+	if((res = f_chmod(path, attr, mask)) != FR_OK) {
+		return fresult2errno(res);
+	}
+
+	return 0;
+}
+
+char *shell_getcwd(char *buf, size_t size)
 {
 	FRESULT ret;
@@ -435,48 +542,39 @@
 }
 
-int chdir(const char *path)
-{
-	FRESULT ret;
-	if ((ret = f_chdir(path)) != FR_OK) {
-		return -1;
-	}
-
-	return 0;
-}
-
-int chroot(const char *path)
-{
-	abort();
-	return -1;
-}
-
-DIR *opendir(const char *path)
-{
-	DIR *dir = malloc(sizeof(DIR) + sizeof(struct dirent));
-	FRESULT ret;
-	if ((ret = f_opendir(dir, path)) != FR_OK) {
-		free(dir);
-		return NULL;
-	}
-
-	dir->dirent = &dir[1];
-	return dir;
-}
-
-int closedir(DIR *dir)
-{
-	FRESULT ret;
-	if ((ret = f_closedir(dir)) != FR_OK) {
-		free(dir);
-		return -1;
-	}
-
-	free(dir);
-	return 0;
-}
-
-struct dirent *readdir(DIR *dir)
-{
-	struct dirent *de = dir->dirent;
+int shell_chdir(const char *path)
+{
+	FRESULT res;
+	if ((res = f_chdir(path)) != FR_OK) {
+		return fresult2errno(res);
+	}
+
+	return 0;
+}
+
+int shell_chroot(const char *path)
+{
+	shell_abort();
+	return -EPERM;
+}
+
+int dir_close(struct _IO_FILE *fp)
+{
+	FRESULT res;
+	if ((res = f_closedir(&fp->dir)) != FR_OK) {
+		return fresult2errno(res);
+	}
+
+	return 0;
+}
+
+int shell_getdents(int fd, struct dirent *de, size_t len)
+{
+	if (len < sizeof(struct dirent))
+		return -EINVAL;
+
+	struct _IO_FILE *fp = fd_to_fp(fd);
+	if (fp == NULL)
+		return -EBADF;
+
 	FILINFO fno;
 #if _USE_LFN
@@ -485,40 +583,117 @@
 	fno.lfsize = sizeof lfn;
 #endif
-	FRESULT ret;
-	if ((ret = f_readdir(dir, &fno)) != FR_OK || fno.fname[0] == '\0') {
-		return NULL;
+	FRESULT res;
+	if ((res = f_readdir(&fp->dir, &fno)) != FR_OK || fno.fname[0] == '\0') {
+		return fresult2errno(res);
 	}
 
 	memset(de, 0, sizeof(*de));
 #if _USE_LFN
-	strlcpy(de->d_name, *fno.lfname ? fno.lfname : fno.fname, sizeof(de->d_name));
+	ntlibc_strlcpy(de->d_name, *fno.lfname ? fno.lfname : fno.fname, sizeof(de->d_name));
 #else
-	strlcpy(de->d_name, fno.fname, sizeof(de->d_name));
+	ntlibc_strlcpy(de->d_name, fno.fname, sizeof(de->d_name));
 #endif
 
-	return de;
-}
-
-void rewinddir(DIR *dir)
-{
-	FRESULT ret;
-	if ((ret = f_rewinddir(dir)) != FR_OK) {
-		return;
-	}
-}
-
-void seekdir(DIR *dir, long pos)
-{
-	abort();
-}
-
-long telldir(DIR *dir)
-{
-	abort();
-	return 0;
-}
-
-int shell_getpid(int n)
+	return 0;
+}
+
+size_t dir_read(struct _IO_FILE *fp, unsigned char *data, size_t len)
+{
+	return -EPERM;
+}
+
+size_t dir_write(struct _IO_FILE *fp, const unsigned char *data, size_t len)
+{
+	return -EPERM;
+}
+
+off_t dir_seek(struct _IO_FILE *fp, off_t ptr, int dir)
+{
+	FRESULT res;
+
+	if (dir != SEEK_SET)
+		return -EINVAL;
+
+	if (ptr == 0) {
+		if ((res = f_rewinddir(&fp->dir)) != FR_OK) {
+			return fresult2errno(res);
+		}
+	}
+	else {
+		FILINFO fno;
+#if _USE_LFN
+		static char lfn[_MAX_LFN + 1];   /* Buffer to store the LFN */
+		fno.lfname = lfn;
+		fno.lfsize = sizeof lfn;
+#endif
+		if ((res = f_rewinddir(&fp->dir)) != FR_OK) {
+			return fresult2errno(res);
+		}
+
+		for (int i = 0; i < ptr; i++) {
+			if ((res = f_readdir(&fp->dir, &fno)) != FR_OK || fno.fname[0] == '\0') {
+				return fresult2errno(res);
+			}
+		}
+	}
+
+	return ptr;
+}
+
+int dir_ioctl(struct _IO_FILE *fp, int req, void *arg)
+{
+	return -EINVAL;
+}
+
+pid_t shell_getpid(void)
 {
 	return 1;
 }
+
+int shell_access(const char *path, int mode)
+{
+	struct stat st;
+	int ret;
+
+	ret = shell_stat(path, &st);
+	if (ret != 0)
+		return ret;
+
+	return 0;
+}
+
+//#include "../musl-1.1.18/include/bits/limits.h"
+#define PAGE_SIZE 4096
+
+uint32_t  __CmdBase;
+uint32_t  __CmdLimit;
+
+void *shell_brk(void *addr)
+{
+	if (addr == 0) {
+		return (void *)((intptr_t)&__CmdBase + 0x20000);
+	}
+	if ((addr >= (intptr_t)&__CmdBase + 0x20000) && (addr < &__CmdLimit)) {
+		return addr;
+	}
+	return (void *)-1;
+}
+
+void *shell_mmap2(void *start, size_t length, int prot, int flags, int fd, off_t pgoffset)
+{
+	if (fd != -1)
+		return -EINVAL;
+
+	if ((length >= 0) && (length <= (intptr_t)&__CmdLimit - (intptr_t)&__CmdBase - 0x20000)) {
+		return &__CmdBase + 0x20000;
+	}
+	return (void *)-1;
+}
+
+int shell_mprotect(void *addr, size_t len, int prot)
+{
+	//if ((addr >= (intptr_t)&__CmdBase + 0x20000) && ((intptr_t)addr + len < &__CmdLimit)) {
+		return 0;
+	//}
+	//return -1;
+}
Index: EcnlProtoTool/trunk/ntshell/src/main.c
===================================================================
--- EcnlProtoTool/trunk/ntshell/src/main.c	(revision 321)
+++ EcnlProtoTool/trunk/ntshell/src/main.c	(revision 331)
@@ -40,12 +40,10 @@
  */
 
+#include "shellif.h"
 #include <kernel.h>
-#include <t_syslog.h>
 #include <t_stdlib.h>
 #include <sil.h>
-#include <stdlib.h>
+#include <setjmp.h>
 #include <string.h>
-#include <stdio.h>
-#include <setjmp.h>
 #include "syssvc/serial.h"
 #include "syssvc/syslog.h"
@@ -64,17 +62,13 @@
 #include <net/if_var.h>
 #include <netinet/udp_var.h>
-#include <ethernet_api.h>
 #include "ffarch.h"
-#include "gpio_api.h"
 #include "ff.h"
 #include "websocket_fbs.h"
-#include "ntshell.h"
-#include "ntstdio.h"
+#include "core/ntshell.h"
+#include "core/ntlibc.h"
+#include "util/ntstdio.h"
 #include "usrcmd.h"
-#include "ntopt.h"
-
-#ifndef _MSC_VER
-void strcpy_s(char *dst, int size, const char *src);
-#endif
+#include "util/ntopt.h"
+#include "socket_stub.h"
 
 ID ws_api_mailboxid = MAIN_DATAQUEUE;
@@ -86,6 +80,13 @@
 ntstdio_t ntstdio;
 
-const uint8_t mac_addr[6] = {0x00, 0x30, 0x13, 0x06, 0x62, 0xC0};
-const char host_name[] = "GR-PEACH";
+const uint8_t mac_addr[6] = {0x12, 0x34, 0x56, 0x78, 0x9A, 0xBC};
+const struct utsname host_name = {
+	"TOPPERS/ASP3",
+    "GR-PEACH",
+    "3.1.0",
+    "3.1.0",
+    "GR-PEACH",
+    "toppers.jp"
+};
 
 static void netif_link_callback(T_IFNET *ether);
@@ -228,5 +229,5 @@
 	char buf[1];
 	if(serial_rea_dat(SIO_PORTID, buf, 1) != 1)
-		return -1;
+		return -EIO;
 	return buf[0];
 }
@@ -305,5 +306,5 @@
 
 	if (exec) {
-		strcpy_s(command, sizeof(command), "mruby -b 1:/upload/main.mrb");
+		ntlibc_strlcpy(command, "mruby -b 1:/upload/main.mrb", sizeof(command));
 
 		execute_command(1);
@@ -371,13 +372,13 @@
 }
 
-int gethostname(char *name, size_t len)
-{
-	return strlcpy(name, host_name, len);
-}
-
-static int usrcmd_ntopt_callback(int argc, char **argv, void *extobj);
+int shell_uname(struct utsname *uts)
+{
+	return memcpy(uts, &host_name, sizeof(host_name));
+}
+
+static int usrcmd_ntopt_callback(long *args, void *extobj);
 int mruby_exit_code;
 volatile int mruby_state;
-typedef void (*PowerOn_Reset_t)(int argc, char **argv);
+typedef void (*PowerOn_Reset_t)(long *args);
 jmp_buf process_exit;
 
@@ -392,10 +393,52 @@
 }
 
-static int usrcmd_ntopt_callback(int argc, char **argv, void *extobj)
-{
+typedef struct
+{
+	const cmd_table_t *table;
+	int count;
+} cmd_table_info_t;
+
+static const cmd_table_t cmdlist[] = {
+	{"cd", "change directory", usrcmd_cd },
+	{"ls", "list files", usrcmd_ls },
+	{"cp", "copy file", usrcmd_cp },
+	{"rm", "remove file", usrcmd_rm },
+	{"mv", "move file", usrcmd_mv },
+	{"mkdir", "Make directory", usrcmd_mkdir},
+	{"hexdump", "Hex dump", usrcmd_hexdump},
+	{"info", "This is a description text string for info command.", usrcmd_info},
+	{"exit", "Exit Natural Tyny Shell", usrcmd_exit},
+};
+cmd_table_info_t cmd_table_info = { cmdlist, sizeof(cmdlist) / sizeof(cmdlist[0]) };
+
+static int usrcmd_ntopt_callback(long *args, void *extobj)
+{
+	const cmd_table_t *p = cmd_table_info.table;
+	if (ntlibc_strcmp((const char *)args[1], "help") == 0) {
+		usrcmd_help(args[0], (char **)&args[1]);
+	}
+	else for (int i = 0; i < cmd_table_info.count; i++) {
+		if (ntlibc_strcmp((const char *)args[1], p->cmd) == 0) {
+			return p->func(args[0], (char **)&args[1]);
+		}
+		p++;
+	}
 	if (setjmp(process_exit) == 0) {
-		(*((PowerOn_Reset_t *)0x18200000))(argc, argv);
+		(*((PowerOn_Reset_t *)0x18200000))(args);
 	}
 	clean_fd();
+	return 0;
+}
+
+int usrcmd_help(int argc, char **argv)
+{
+	const cmd_table_t *p = cmd_table_info.table;
+	for (int i = 0; i < cmd_table_info.count; i++) {
+		ntstdio_puts(&ntstdio, p->cmd);
+		ntstdio_puts(&ntstdio, "\t:");
+		ntstdio_puts(&ntstdio, p->desc);
+		ntstdio_puts(&ntstdio, "\n");
+		p++;
+	}
 	return 0;
 }
@@ -422,4 +465,10 @@
 
 void shell_exit(int exitcd)
+{
+	mruby_exit_code = exitcd;
+	longjmp(process_exit, 1);
+}
+
+void shell_exit_group(int exitcd)
 {
 	mruby_exit_code = exitcd;
@@ -458,5 +507,5 @@
 static int cmd_execute(const char *text, void *extobj)
 {
-	strlcpy(command, text, sizeof(command));
+	ntlibc_strlcpy(command, text, sizeof(command));
 	return execute_command(1);
 }
@@ -464,15 +513,15 @@
 int stdio_close(struct _IO_FILE *fp)
 {
-	return -1;
+	return -EPERM;
 }
 
 size_t stdio_read(struct _IO_FILE *fp, unsigned char *data, size_t len)
 {
-	return -1;
+	return -EPERM;
 }
 
 size_t stdio_write(struct _IO_FILE *fp, const unsigned char *data, size_t len)
 {
-	return -1;
+	return -EPERM;
 }
 
@@ -507,14 +556,141 @@
 int sio_close(struct _IO_FILE *fp)
 {
-	return -1;
+	return -EPERM;
 }
 
 size_t sio_read(struct _IO_FILE *fp, unsigned char *data, size_t len)
 {
-	return -1;
+	return -EPERM;
 }
 
 size_t sio_write(struct _IO_FILE *fp, const unsigned char *data, size_t len)
 {
-	return -1;
-}
+	return -EPERM;
+}
+
+off_t sio_seek(struct _IO_FILE *fp, off_t ofs, int org)
+{
+	return -EPERM;
+}
+
+int sio_ioctl(struct _IO_FILE *fp, int request, void *arg)
+{
+	switch (request) {
+	case TIOCGWINSZ:
+		return 0;
+	case TCGETS:
+		return sio_tcgetattr(fp->fd, (struct termios *)arg);
+	case TCSETS + TCSANOW:
+	case TCSETS + TCSADRAIN:
+	case TCSETS + TCSAFLUSH:
+		return sio_tcsetattr(fp->fd, request - TCSETS, (const struct termios *)arg);
+	}
+
+	return -EINVAL;
+}
+
+int shell_clock_getres(clockid_t clk_id, struct timespec *res)
+{
+	if (clk_id != CLOCK_REALTIME)
+		return -EINVAL;
+
+	memset(&res->tv_sec, 0xFF, sizeof(res->tv_sec));
+	res->tv_nsec = 0;
+
+	return 0;
+}
+
+int shell_clock_gettime(clockid_t clk_id, struct timespec *tp)
+{
+	SYSTIM now = 0;
+
+	if (clk_id != CLOCK_REALTIME)
+		return -EINVAL;
+
+	get_tim(&now);
+	tp->tv_sec = now / 1000000;
+	tp->tv_nsec = (now % 1000000) * 1000;
+
+	return 0;
+}
+
+int shell_clock_settime(clockid_t clk_id, const struct timespec *tp)
+{
+	if (clk_id != CLOCK_REALTIME)
+		return -EINVAL;
+
+	rtc_write(tp->tv_sec);
+
+	return 0;
+}
+
+sigset_t g_sigmask;
+
+int shell_sigprocmask(int how, const sigset_t *restrict set, sigset_t *restrict old)
+{
+	if (old != NULL)
+		memcpy(old, &g_sigmask, sizeof(sigset_t));
+
+	switch (how) {
+	case SIG_BLOCK:
+		for (int i = 0; i < sizeof(g_sigmask.__bits) / sizeof(g_sigmask.__bits[0]); i++) {
+			g_sigmask.__bits[i] |= set->__bits[i];
+		}
+		break;
+	case SIG_UNBLOCK:
+		for (int i = 0; i < sizeof(g_sigmask.__bits) / sizeof(g_sigmask.__bits[0]); i++) {
+			g_sigmask.__bits[i] &= ~set->__bits[i];
+		}
+		break;
+	case SIG_SETMASK:
+		memcpy(&g_sigmask, set, sizeof(sigset_t));
+		break;
+	default:
+		return -EINVAL;
+	}
+
+	return 0;
+}
+
+struct sigaction sigtable[6];
+
+int shell_sigaction(int sig, const struct sigaction *restrict sa, struct sigaction *restrict old)
+{
+	struct sigaction *sat;
+
+	switch(sig){
+	case SIGALRM:
+		sat = &sigtable[0];
+		break;
+	case SIGFPE:
+		sat = &sigtable[1];
+		break;
+	case SIGILL:
+		sat = &sigtable[2];
+		break;
+	case SIGSEGV:
+		sat = &sigtable[3];
+		break;
+	case SIGBUS:
+		sat = &sigtable[4];
+		break;
+	case SIGABRT:
+		sat = &sigtable[5];
+		break;
+	default:
+		return -EINVAL;
+	}
+
+	if (old != NULL)
+		memcpy(old, sat, sizeof(struct sigaction));
+
+	memcpy(sat, sa, sizeof(struct sigaction));
+
+	return 0;
+}
+
+int shell_madvise(void *a, size_t b, int c)
+{
+	return 0;
+}
+
Index: EcnlProtoTool/trunk/ntshell/src/main.cfg
===================================================================
--- EcnlProtoTool/trunk/ntshell/src/main.cfg	(revision 321)
+++ EcnlProtoTool/trunk/ntshell/src/main.cfg	(revision 331)
@@ -61,4 +61,4 @@
 CRE_SEM(SEM_FILESYSTEM, { TA_TPRI, 1, 1 });
 
-CRE_TSK(MRUBY_TASK, { TA_NULL, 0, mruby_task, MRUBY_PRIORITY, MRUBY_STACK_SIZE, (void *)0x20600000 });
+CRE_TSK(MRUBY_TASK, { TA_NULL, 0, mruby_task, MRUBY_PRIORITY, MRUBY_STACK_SIZE, (void *)0x20100000 });
 CRE_FLG(FLG_SELECT_WAIT, { TA_WMUL, 0x00 });
Index: EcnlProtoTool/trunk/ntshell/src/main.h
===================================================================
--- EcnlProtoTool/trunk/ntshell/src/main.h	(revision 321)
+++ EcnlProtoTool/trunk/ntshell/src/main.h	(revision 331)
@@ -56,5 +56,5 @@
 
 #define MAIN_STACK_SIZE		2048	/* メインタスクのスタック領域のサイズ */
-#define MRUBY_STACK_SIZE	0x100000	/* mruby実行タスクのスタック領域のサイズ */
+#define MRUBY_STACK_SIZE	0x00800000	/* mruby実行タスクのスタック領域のサイズ */
 
 #define NUM_MAIN_DATAQUEUE	1	/* メインタスクで待ち受けているデータキューのサイズ */
